public with sharing class TestFieldValues {
	
	public void testFieldValues(){
		List<TestFieldValues.FieldSummary> fieldSummarys = getFieldValues('ZkFpiKRSLubIVJFyFC3jezR-084=');
		
		for(TestFieldValues.FieldSummary fieldSummary: fieldSummarys){
			System.debug(fieldSummary.signerId  + ' || ' + fieldSummary.documentId + ' || ' + fieldSummary.fieldId + ' || ' + fieldSummary.fieldValue);
		}
		
	}
	
    
    public class FieldSummary 
    {
        public String signerId;
	    public String documentId;
	    public String fieldId;
	    public String fieldValue;
	    public String fieldName;

        public FieldSummary(){}

        public FieldSummary(String signerId,String documentId,String fieldId,String fieldValue,String fieldName)
        {
            this.signerId = signerId;
            this.documentId = documentId;
            this.fieldId = fieldId;
            this.fieldValue = fieldValue;
            this.fieldName = fieldName;
        }
    }
    
    
    public List<TestFieldValues.FieldSummary> getFieldValues(String packageId){
    	String resourceUrl = '/packages/'+packageId+'/fieldSummary';
        HttpResponse response = doGet(resourceUrl);

        // Check response
        List<TestFieldValues.FieldSummary> fieldSummarys = new List<TestFieldValues.FieldSummary>();
        if(response.getStatusCode() == 200)
        {
            try
            {
            	List<Object> fieldSummarysList = (List<Object>)JSON.deserializeUntyped(response.getBody());
            	for(Object fieldSummaryObject: fieldSummarysList){
            		fieldSummarys.add((TestFieldValues.FieldSummary)JSON.deserialize(JSON.serialize(fieldSummaryObject), TestFieldValues.FieldSummary.class));
            	}
            }
            catch(Exception e)
            {
                throw new ESignLiveRESTAPIHelper.ESignLiveRestAPIHelperException('Error parsing field summary ' + e.getMessage());
            }
        }
        else
        {
            throw new ESignLiveRESTAPIHelper.ESignLiveRestAPIHelperException('Error get Field Values ' + response.getStatusCode() + ' - ' + response.getStatus() + ' - ' +  response.getBody());  
        }

        return fieldSummarys;
    }
    
    private HttpResponse doGet(String resourceUrl){
        e_SignLive_Connection_Settings__c connectionSettings = e_SignLive_Connection_Settings__c.getInstance('Main');    
         // Build Request
        HttpRequest request = new HttpRequest();
        request.setEndpoint(connectionSettings.Endpoint__c + resourceUrl);
        request.setMethod('GET');
        request.setHeader('Authorization', 'Basic ' + connectionSettings.API_Key__c);
        request.setHeader('Content-type', 'application/json');

        // Send Request
        HttpResponse response = (new Http()).send(request);

        if(response != null && (response.getHeader('Content-Type')).contains('json'))
        {
            System.debug('=> Formating for JSON response');
            // Format responseBody string before returning
            String inboundResponseBody = ESignLiveJSONHelper.prepareInboundJSON(response.getBody());
            response.setBody(inboundResponseBody);
        }

        return response;
    }
    
}